KFind class Reference (kutils Library)

| # kutils Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KFind Class Reference

A generic implementation of the "find" function. More...

`#include <kfind.h>`

Inheritance diagram for KFind:

[legend]
Collaboration diagram for KFind:

[legend]
List of all members.

## Public Types
enum | Result { NoMatch, Match }
## Signals
void | highlight (const QString &text, int matchingIndex, int matchedLength)
| Connect to this signal to implement highlighting of found text during the find operation.
void | findNext ()
void | optionsChanged ()
| Emitted when the options have changed.
void | dialogClosed ()
| Emitted when the 'find next' dialog is being closed.
## Public Member Functions
| KFind (const QString &pattern, long options, QWidget *parent)
bool | needData () const
void | setData (const QString &data, int startPos=-1)
| Call this when needData returns true, before calling find().
Result | find ()
| Walk the text fragment (e.g.
long | options () const
| Return the current options.
virtual void | setOptions (long options)
| Set new options.
int | numMatches () const
| Return the number of matches found (i.e.
virtual void | resetCounts ()
| Call this to reset the numMatches count (and the numReplacements count for a KReplace).
virtual bool | validateMatch (const QString &, int, int)
| Virtual method, which allows applications to add extra checks for validating a candidate match.
virtual bool | shouldRestart (bool forceAsking=false, bool showNumMatches=true) const
| Returns true if we should restart the search from scratch.
virtual void | displayFinalDialog () const
| Displays the final dialog saying "no match was found", if that was the case.
KDialogBase * | findNextDialog (bool create=false)
| Return (or create) the dialog that shows the "find next?" prompt.
void | closeFindNextDialog ()
| Close the "find next?" dialog.
## Static Public Member Functions
int | find (const QString &text, const QString &pattern, int index, long options, int *matchedlength)
| Search the given string, and returns whether a match was found.
int | find (const QString &text, const QRegExp &pattern, int index, long options, int *matchedlength)
## Protected Slots
void | slotFindNext ()
void | slotDialogClosed ()
## Protected Member Functions
| KFind (const QString &pattern, const QString &replacement, long options, QWidget *parent)
QWidget * | parentWidget () const
## Friends
class | KReplace

## Detailed Description

A generic implementation of the "find" function.

Author:
  S.R.Haque <srhaque@iee.org>, David Faure <faure@kde.org>

Detail

This class includes prompt handling etc. Also provides some static functions which can be used to create custom behaviour instead of using the class directly.

Example

To use the class to implement a complete find feature:

In the slot connected to the find action, after using KFindDialog:

      // This creates a find-next-prompt dialog if needed.
      m_find = new KFind(pattern, options);

      // Connect highlight signal to code which handles highlighting
      // of found text.
      connect( m_find, SIGNAL( highlight( const QString &, int, int ) ),
              this, SLOT( slotHighlight( const QString &, int, int ) ) );
      // Connect findNext signal - called when pressing the button in the dialog
      connect( m_find, SIGNAL( findNext() ),
              this, SLOT( slotFindNext() ) );

Then initialize the variables determining the "current position" (to the cursor, if the option FromCursor is set, to the beginning of the selection if the option SelectedText is set, and to the beginning of the document otherwise). Initialize the "end of search" variables as well (end of doc or end of selection). Swap begin and end if FindBackwards. Finally, call slotFindNext();

      void slotFindNext()
      {
          KFind::Result res = KFind::NoMatch;
          while ( res == KFind::NoMatch &&  ) {
              if ( m_find->needData() )
                  m_find->setData( <current text fragment> );

              // Let KFind inspect the text fragment, and display a dialog if a match is found
              res = m_find->find();

              if ( res == KFind::NoMatch ) {
                  <Move to the next non-empty text fragment, honouring the FindBackwards setting for the direction>
              }
          }

          if ( res == KFind::NoMatch ) // i.e. at end
              <Call either  m_find->displayFinalDialog(); delete m_find; m_find = 0L;
               or           if ( m_find->shouldRestart() ) { reinit and call slotFindNext(); }
                            else { delete m_find; m_find = 0L; }>
      }

Don't forget delete m_find in the destructor of your class, unless you gave it a parent widget on construction.

This implementation allows to have a "Find Next" action, which resumes the search, even if the user closed the "Find Next" dialog.

A "Find Previous" action can simply switch temporarily the value of FindBackwards and call slotFindNext() - and reset the value afterwards.

Definition at line 97 of file kfind.h.

## Member Function Documentation

bool KFind::needData | ( |  | ) | const

| Returns: true if the application must supply a new text fragment It also means the last call returned "NoMatch". But by storing this here the application doesn't have to store it in a member variable (between calls to slotFindNext()). Definition at line 81 of file kfind.cpp. References QString::length().

void KFind::setData | ( | const QString & | data,
|  | int | startPos = -1
| ) |

  | Call this when needData returns true, before calling find(). Parameters:
  data | the text fragment (line)
  startPos | if set, the index at which the search should start. This is only necessary for the very first call to setData usually, for the 'find in selection' feature. A value of -1 (the default value) means "process all the data", i.e. either 0 or data.length()-1 depending on FindBackwards.
Definition at line 90 of file kfind.cpp. References QString::length().

KFind::Result KFind::find | ( |  | ) |

| Walk the text fragment (e.g. text-processor line, kspread cell) looking for matches. For each match, emits the highlight() signal and displays the find-again dialog proceeding. Definition at line 117 of file kfind.cpp. References findNextDialog(), highlight(), QDialog::show(), and validateMatch(). Referenced by find(), and KReplace::replace().

long KFind::options | ( |  | ) | const`[inline]`

| Return the current options. Warning: this is usually the same value as the one passed to the constructor, but options might change _during_ the replace operation: e.g. the "All" button resets the PromptOnReplace flag. Definition at line 142 of file kfind.h.

void KFind::setOptions | ( | long | options | ) | `[virtual]`

| Set new options. Usually this is used for setting or clearing the FindBackwards options. Definition at line 383 of file kfind.cpp.

int KFind::numMatches | ( |  | ) | const`[inline]`

| Return the number of matches found (i.e. the number of times the highlight signal was emitted). If 0, can be used in a dialog box to tell the user "no match was found". The final dialog does so already, unless you used setDisplayFinalDialog(false). Definition at line 156 of file kfind.h. Referenced by displayFinalDialog().

virtual void KFind::resetCounts | ( |  | ) | `[inline, virtual]`

| Call this to reset the numMatches count (and the numReplacements count for a KReplace). Can be useful if reusing the same KReplace for different operations, or when restarting from the beginning of the document. Reimplemented in KReplace. Definition at line 164 of file kfind.h. Referenced by KReplace::resetCounts().

virtual bool KFind::validateMatch | ( | const QString & | ,
|  | int | ,
|  | int |
| ) | `[inline, virtual]`

  | Virtual method, which allows applications to add extra checks for validating a candidate match. It's only necessary to reimplement this if the find dialog extension has been used to provide additional criterias. Parameters:
  text | The current text fragment
  index | The starting index where the candidate match was found
  matchedlength | The length of the candidate match
Definition at line 176 of file kfind.h. Referenced by find(), and KReplace::replace().

bool KFind::shouldRestart | ( | bool | forceAsking = false,
|  | bool | showNumMatches = true
| ) | const`[virtual]`

  | Returns true if we should restart the search from scratch. Can ask the user, or return false (if we already searched the whole document). Parameters:
  forceAsking | set to true if the user modified the document during the search. In that case it makes sense to restart the search again.
  showNumMatches | set to true if the dialog should show the number of matches. Set to false if the application provides a "find previous" action, in which case the match count will be erroneous when hitting the end, and we could even be hitting the beginning of the document (so not all matches have even been seen).
Reimplemented in KReplace. Definition at line 356 of file kfind.cpp. References displayFinalDialog(), and KMessageBox::questionYesNo().

int KFind::find | ( | const QString & | text,
|  | const QString & | pattern,
|  | int | index,
|  | long | options,
|  | int * | matchedlength
| ) | `[static]`

  | Search the given string, and returns whether a match was found. If one is, the length of the string matched is also returned. A performance optimised version of the function is provided for use with regular expressions. Parameters:
  text | The string to search.
  pattern | The pattern to look for.
  index | The starting index into the string.
  options. | The options to use.
Returns: The index at which a match was found, or -1 if no match was found. Definition at line 181 of file kfind.cpp. References QString::find(), find(), QString::findRev(), and QString::length().

void KFind::displayFinalDialog | ( |  | ) | const`[virtual]`

| Displays the final dialog saying "no match was found", if that was the case. Call either this or shouldRestart(). Reimplemented in KReplace. Definition at line 346 of file kfind.cpp. References QString::arg(), KMessageBox::information(), and numMatches(). Referenced by shouldRestart().

KDialogBase * KFind::findNextDialog | ( | bool | create = false | ) |

| Return (or create) the dialog that shows the "find next?" prompt. Usually you don't need to call this. One case where it can be useful, is when the user selects the "Find" menu item while a find operation is under way. In that case, the program may want to call setActiveWindow() on that dialog. Definition at line 106 of file kfind.cpp. References QObject::connect(), and KStdAction::create(). Referenced by find().

void KFind::closeFindNextDialog | ( |  | ) |

| Close the "find next?" dialog. The application should do this when the last match was hit. If the application deletes the KFind, then "find previous" won't be possible anymore. Definition at line 388 of file kfind.cpp. Referenced by KReplace::closeReplaceNextDialog().

void KFind::highlight | ( | const QString & | text,
|  | int | matchingIndex,
|  | int | matchedLength
| ) | `[signal]`

| Connect to this signal to implement highlighting of found text during the find operation. Referenced by find(), and KReplace::replace().

void KFind::optionsChanged | ( |  | ) | `[signal]`

| Emitted when the options have changed. This can happen e.g. with "Replace All", or if our 'find next' dialog gets a "find previous" one day.

void KFind::dialogClosed | ( |  | ) | `[signal]`

| Emitted when the 'find next' dialog is being closed. Some apps might want to remove the highlighted text when this happens. Apps without support for "Find Next" can also do m_find->deleteLater() to terminate the find operation.

The documentation for this class was generated from the following files:

- kfind.h
- kfind.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:28:06 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001